--- ./include/views/configuration.item.list.php.orig	2014-07-17 15:49:46.000000000 +0200
+++ ./include/views/configuration.item.list.php	2014-08-17 19:57:54.000000000 +0200
@@ -55,7 +55,26 @@
 }
 
 // create table
+$expRedKeyIcoItem = new CImg('images/general/plus.png');
+$expRedKeyIcoItem->setAttribute('id', 'expRedKeyIco');
+$expRedKeyIcoUrl = 'javascript:expandReduce(".expRedKey", "'._('[show]').'", "'._('[hide]').'", "#expRedKeyIco");';
+$expRedKeyIcoLnk = new CLink($expRedKeyIcoItem, $expRedKeyIcoUrl, null, null, false);
+$expRedKeyIco = new CSpan(array(SPACE, $expRedKeyIcoLnk));
+
+$expRedAppIcoItem = new CImg('images/general/plus.png');
+$expRedAppIcoItem->setAttribute('id', 'expRedAppIco');
+$expRedAppIcoUrl = 'javascript:expandReduce(".expRedApp", "'._('[show]').'", "'._('[hide]').'", "#expRedAppIco");';
+$expRedAppIcoLnk = new CLink($expRedAppIcoItem, $expRedAppIcoUrl, null, null, false);
+$expRedAppIco = new CSpan(array(SPACE, $expRedAppIcoLnk));
+
+$expRedErrIcoItem = new CImg('images/general/plus.png');
+$expRedErrIcoItem->setAttribute('id', 'expRedErrIco');
+$expRedErrIcoUrl = 'javascript:expandReduce(".expRedErr", "'._('[show]').'", "'._('[hide]').'", "#expRedErrIco");';
+$expRedErrIcoLnk = new CLink($expRedErrIcoItem, $expRedErrIcoUrl, null, null, false);
+$expRedErrIco = new CSpan(array(SPACE, $expRedErrIcoLnk));
+
 $itemTable = new CTableInfo(_('No items found.'));
+
 $itemTable->setHeader(array(
 	new CCheckBox('all_items', null, "checkAll('".$itemForm->getName()."', 'all_items', 'group_itemid');"),
 	$this->data['displayNodes'] ? _('Node') : null,
@@ -63,14 +82,14 @@
 	empty($this->data['filter_hostid']) ? _('Host') : null,
 	make_sorting_header(_('Name'), 'name'),
 	_('Triggers'),
-	make_sorting_header(_('Key'), 'key_'),
+	make_sorting_header(_('Key'), 'key_', null, $expRedKeyIco),
 	make_sorting_header(_('Interval'), 'delay'),
 	make_sorting_header(_('History'), 'history'),
 	make_sorting_header(_('Trends'), 'trends'),
 	make_sorting_header(_('Type'), 'type'),
-	_('Applications'),
+	array(_('Applications'), $expRedAppIco),
 	make_sorting_header(_('Status'), 'status'),
-	$data['showErrorColumn'] ? _('Error') : null
+	$data['showErrorColumn'] ? array(_('Error'), $expRedErrIco) : null
 ));
 
 foreach ($this->data['items'] as $item) {
@@ -250,6 +269,21 @@
 	$checkBox = new CCheckBox('group_itemid['.$item['itemid'].']', null, null, $item['itemid']);
 	$checkBox->setEnabled(empty($item['discoveryRule']));
 
+	$expRedKeyLnkUrl = 'javascript:expandReduce(".expRedKey' . $item['itemid'].'", "'._('[show]').'", "'._('[hide]').'");';
+	$expRedKeyLnk = new CLink(_('[show]'), $expRedKeyLnkUrl, 'expRedKey'.$item['itemid'].' expRedKey', null, false);
+	$itemKeyClass = "expRedKey${item['itemid']}_long expRedKey_long hidden";
+	$itemKey = new CCol(array(new CDiv(CHtml::encode($item['key_']), $itemKeyClass), $expRedKeyLnk));
+
+	$expRedAppLnkUrl = 'javascript:expandReduce(".expRedApp' . $item['itemid'].'", "'._('[show]').'", "'._('[hide]').'");';
+	$expRedAppLnk = new CLink(_('[show]'), $expRedAppLnkUrl, 'expRedApp'.$item['itemid'].' expRedApp', null, false);
+	$applicationsClass = "expRedApp${item['itemid']}_long expRedApp_long hidden wraptext";
+	$applications = new CCol(array(new CDiv(CHtml::encode($item['applications_list'], 'wraptext'), $applicationsClass), $expRedAppLnk));
+
+	if (empty($item['error'])) $item['error'] = '-';
+	$itemErrorClass = "expRedErr${item['itemid']}_long expRedErr_long hidden";
+	$statusIconsClass = "expRedErr${item['itemid']}_short expRedErr_short visible";
+	$statusIcons = new CCol(array(new CDiv($statusIcons, $statusIconsClass), new CDiv($item['error'], $itemErrorClass)));
+
 	$itemTable->addRow(array(
 		$checkBox,
 		$this->data['displayNodes'] ? $item['nodename'] : null,
@@ -257,12 +291,12 @@
 		empty($this->data['filter_hostid']) ? $item['host'] : null,
 		$description,
 		$triggerInfo,
-		CHtml::encode($item['key_']),
+		$itemKey,
 		$item['type'] == ITEM_TYPE_TRAPPER || $item['type'] == ITEM_TYPE_SNMPTRAP ? '' : $item['delay'],
 		$item['history'],
 		in_array($item['value_type'], array(ITEM_VALUE_TYPE_STR, ITEM_VALUE_TYPE_LOG, ITEM_VALUE_TYPE_TEXT)) ? '' : $item['trends'],
 		item_type2str($item['type']),
-		new CCol(CHtml::encode($item['applications_list']), 'wraptext'),
+		$applications,
 		$status,
 		$data['showErrorColumn'] ? $statusIcons : null
 	));