--- ./include/views/js/configuration.services.edit.js.php.orig	2014-08-27 21:13:51.000000000 +0200
+++ ./include/views/js/configuration.services.edit.js.php	2014-08-27 21:48:32.000000000 +0200
@@ -46,9 +46,13 @@
 			url.setAttribute('href', 'services.php?form=1&serviceid=' + serviceid);
 			url.appendChild(document.createTextNode(name));
 
+			var urlServiceId = document.createElement('span');
+			urlServiceId.appendChild(document.createTextNode(' (' + t('Node ID') + ': ' + serviceid + ')'));
+
 			td.appendChild(inputServiceId);
 			td.appendChild(inputName);
 			td.appendChild(url);
+			td.appendChild(urlServiceId);
 			tr.appendChild(td);
 
 			// column "soft"
--- ./include/views/configuration.services.child.list.php.orig	2014-07-17 15:49:46.000000000 +0200
+++ ./include/views/configuration.services.child.list.php	2014-08-27 20:39:23.000000000 +0200
@@ -55,7 +55,7 @@
 
 	$servicesChildTable->addRow(array(
 		$cb,
-		array($prefix, $description),
+		array($prefix, $description, SPACE, '('._('Node ID').': '.$service['serviceid'].')'),
 		serviceAlgorythm($service['algorithm']),
 		$service['trigger'])
 	);
--- ./include/views/configuration.services.edit.php.orig	2014-07-17 15:49:46.000000000 +0200
+++ ./include/views/configuration.services.edit.php	2014-08-27 20:45:27.000000000 +0200
@@ -48,7 +48,7 @@
 
 // append parent link to form list
 $servicesFormList->addRow(_('Parent service'), array(
-	new CTextBox('parent_name', $this->data['parentname'], ZBX_TEXTBOX_STANDARD_SIZE, 'yes', 128),
+	new CTextBox('parent_name', $this->data['parentname'].' ('._('Node ID').': '.$this->data['parentid'].')', ZBX_TEXTBOX_STANDARD_SIZE, 'yes', 128),
 	new CButton('select_parent', _('Change'), "javascript: openWinCentered('services.php?pservices=1".url_param('serviceid')."', 'ZBX_Services_List', 740, 420, 'scrollbars=1, toolbar=0, menubar=0, resizable=1, dialog=0');", 'formlist')
 ));
 
@@ -94,6 +94,7 @@
 	$row = new CRow(array(
 		array(
 			new CLink($child['name'], 'services.php?form=1&serviceid='.$child['serviceid']),
+			new CSpan(' ('._('Node ID').': '.$child['serviceid'].')'),
 			new CVar('children['.$child['serviceid'].'][name]', $child['name']),
 			new CVar('children['.$child['serviceid'].'][serviceid]', $child['serviceid'])
 		),
--- ./include/views/configuration.services.parent.list.php.orig	2014-07-17 15:49:46.000000000 +0200
+++ ./include/views/configuration.services.parent.list.php	2014-08-27 19:24:16.000000000 +0200
@@ -51,13 +51,13 @@
 foreach ($this->data['db_pservices'] as $db_service) {
 	$description = new CSpan($db_service['name'], 'link');
 	$description->setAttribute('onclick', 'javascript:
-		jQuery(\'#parent_name\', window.opener.document).val('.zbx_jsvalue($db_service['name']).');
+		jQuery(\'#parent_name\', window.opener.document).val('.zbx_jsvalue($db_service['name'].' ('._('Node ID').': '.$db_service['serviceid'].')').');
 		jQuery(\'#parentname\', window.opener.document).val('.zbx_jsvalue($db_service['name']).');
 		jQuery(\'#parentid\', window.opener.document).val('.zbx_jsvalue($db_service['serviceid']).');
 		self.close();
 		return false;'
 	);
-	$servicesParentTable->addRow(array(array($prefix, $description), serviceAlgorythm($db_service['algorithm']), $db_service['trigger']));
+	$servicesParentTable->addRow(array(array($prefix, $description, SPACE, '('._('Node ID').': '.$db_service['serviceid'].')'), serviceAlgorythm($db_service['algorithm']), $db_service['trigger']));
 }
 $column = new CCol(new CButton('cancel', _('Cancel'), 'javascript: self.close();'));
 $column->setAttribute('style', 'text-align:right;');
--- ./include/services.inc.php.orig	2014-07-17 15:49:47.000000000 +0200
+++ ./include/services.inc.php	2014-08-27 19:24:16.000000000 +0200
@@ -156,7 +156,7 @@
 
 		$serviceNode = array(
 			'id' => $service['serviceid'],
-			'caption' => $caption,
+			'caption' => array($caption, SPACE, new CSpan(' ('._('Node ID').': '.$service['serviceid'].')')),
 			'description' => ($service['trigger']) ? $service['trigger']['description'] : '-',
 			'parentid' => ($parentService) ? $parentService['serviceid'] : 0,
 			'algorithm' => serviceAlgorythm($service['algorithm'])